a2862433
2015-07-08 09:49
采纳率: 100%
浏览 3.1k
已采纳

在把spring spring-webmvc和 spring-web 作为源码引入的问题

之前一直都用的jar包,今天想debug里面的代码,所有想把spring两个需要研究代码的jar包作为源码引入,在spring下载源码解压,引入项目工程如图: 图片说明
然后观察,里面的一下代码也在报错,貌似引用了一些其他的jar包,暂时没管它如图: 图片说明
然后启动项目,控制台保存如下:
图片说明
debug报错代码发现在 RequestMappingHandlerAdapter类执行代码resolvers.add(new ServletRequestMethodArgumentResolver()); 报错
然后进入看此类发现它居然import了这个东西:
图片说明
百度一下发现java.time.ZoneId不是Java8的东西吗?
我现在就想问,为啥之前用jar包的时候也没报错啊?
jar包的版本和source的版本都是4.0.5,我把jar包反编译了,class类里面也在引用import java.time.ZoneId; 这个东西。
Java环境也同样是在7上。

  • 写回答
  • 好问题 提建议
  • 追加酬金
  • 关注问题
  • 收藏
  • 邀请回答

4条回答 默认 最新

  • DefunctMan 2015-07-12 02:08
    已采纳

    其实人家发布4.0的时候已经支持Java8特性了,你可以选择在编译的时候支持这些特性。
    不过Spring Frame在打包的时候已经能够做到自动感知你的环境决定版本了。

    也就是lib包会根据你的环境加载类,
    但是代码就做不到了,你可以选择eclipse 为Jdk8 版本,complie 选项run config选项里面制定你的运行环境

    参考链接:
    https://spring.io/blog/2015/04/03/how-spring-achieves-compatibility-with-java-6-7-and-8

    觉得说得对,就打赏吧,不对就来交流一下你的想法。

    评论
    解决 无用
    打赏 举报
查看更多回答(3条)

相关推荐 更多相似问题